<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<?php
require 'dfg-conf.inc.php';

/* PHP save_mode? */
if (ini_get('safe_mode')) $safemode = true;
else $safemode = false;

$src = $_GET['src'];
if (!preg_match("/[\/]$/", $src)) $src = $src . "/";

if (!isset($_GET['img'])) $img=0;
else $img = $_GET['img'];

/* Repair image name, if given without ".jpg" extension: */

if (!is_file($src ."images/". $img))
  $img = $img . ".jpg";

$full_size = $_GET['full_size'];

if (is_file($src . "fotos-conf.inc.php")) include $src . 'fotos-conf.inc.php';

// Engl. Galerie-Titel nehmen, falls kein deutscher verfuegbar:
if (!isset($TITLE_D) || ($TITLE_D == "" && $TITLE !== ""))
  $TITLE_D = $TITLE;

include 'dfg_version.php';

/* liest die Bilder ein */
$dir = $src . "images";
if ($handle = opendir($dir)) {
    while (false !== ($file = readdir($handle))) { 
      if (is_file($dir."/".$file)) {
	$images[] = $file;
      }
    }
    sort($images);
    $size = count($images);
    
    closedir($handle); 

    // Mit $img wird jetzt der Dateiname uebergeben, $img_nr ist der Index 
    $img_nr = 0;

    while ( $img_nr < $size && $images[$img_nr] !== $img ){
	$img_nr++;
    }
    if ($img_nr > 0){
	$img_left = strip_jpg($images[$img_nr-1]);
    }
    if ($img_nr < $size){
	$img_right = strip_jpg($images[$img_nr+1]);
    }
}

/* Berechnung der Thumbnailseite */

$seite = ceil(($img_nr + 0.1) / $BPS);
  

// Titel und Text zu dem aktuellen Bild laden
// img_title_ger wird auf sinnvollen Wert gesetzt, aber normalerweise beim Lesen von $text_file ueberschrieben
$img_title_ger = "";
$img_title="";
$img_text="";
$img_text_ger = "";
// Der Name der Datei, die die Beschreibungen enthaelt:
$text_file= $src . "text/" . $img . ".txt";

if (file_exists($text_file)) {
  include $text_file;
}
// Falls kein deutscher Titel da ist...
if ($img_title_ger == ""){
  if ($img_title !== "")
    $img_title_ger = $img_title; // ...nimm' den englischen
  else { // ... oder generiere einen, wenn der auch nicht da ist:
    $img_title_ger = "Bild " . ($img_nr + 1) . "/" . $size;
  }
}
// Falls keine deutschen Kommentare vorhanden, aber englische, dann werden die genommen:
if ($img_text_ger == "" && $img_text !== "") $img_text_ger = "<i>Englische Beschreibung:</i><br>" . $img_text;

include 'dfg-login.inc.php';

/* Admin-Modus */
if ($_COOKIE["dfg-Admin"] != null && $PASSWORD == $_COOKIE['dfg-Admin']) {
  /* Text speichern */
  if ($_POST['saveText']) { //save=1
    save($text_file);
    /* re-read the text_file to immediately display any changes: */
    include $text_file;
  }

  /* umbenennen */
  if ($_POST['chk_rename']) {
    $newname = $_POST['rename'];
    if (is_file($src . "images/".$newname) || is_file($src .$IMGDIR_DEFAULT."/". $newname) || is_file($src . "thumbs/".$newname)) die("<strong>FEHLER:</strong> Die Datei ".$newname." existiert bereits!");
    if (is_file($src ."images/". $img)) {
      if (is_writeable($src ."images/". $img)) {
	rename($src . "images/". $img,$src . "images/".$newname);
      }
      else die("<strong>FEHLER:</strong> Die Datei ".$src ."images/". $img." ist schreibgesch&uuml;tzt!");
    }

    if (is_file($src .$IMGDIR_DEFAULT."/". $img)) {
      if (is_writeable($src .$IMGDIR_DEFAULT."/". $img)) {
	rename($src .$IMGDIR_DEFAULT."/". $img,$src .$IMGDIR_DEFAULT."/". $newname);
      }
      else die( "<strong>FEHLER:</strong> Die Datei ".$src .$IMGDIR_DEFAULT."/". $img." ist schreibgesch&uuml;tzt!");
    }

    if (is_file($src ."thumbs/". $images[$img])) rename($src . "thumbs/". $img,$src . "thumbs/".$newname);

    if (is_file($src ."text/". $images[$img].".txt")) rename($src . "text/". $img.".txt",$src . "text/".$newname.".txt");

    /* Pfade zu Bild und Text-Datei anpassen */
    $img=$newname;
    $text_file = $src . "text/" . $img . ".txt";
  }

  /* Bilddaten loeschen */
  if ($_POST['delImg']) {
    $imgsrc = $dir ."/". $img;
    if (is_file($imgsrc)) {
      if (is_writeable($imgsrc)) {
	unlink($imgsrc) or die("<strong>FEHLER:</strong> Die Datei $imgsrc konnte nicht gel&ouml;scht werden!");
      } 
      else die("<strong>FEHLER:</strong> Die Datei ".$imgsrc." ist schreibgesch&uuml;tzt!");
    }

    $imgorg=$src . $IMGDIR_DEFAULT ."/". $img;
    if (is_file($imgorg)) {
      if (is_writeable($imgorg)) {
	unlink($imgorg) or die("<strong>FEHLER:</strong> Die Datei $imgorg konnte nicht gel&ouml;scht werden!");
      }
      else die( "<strong>FEHLER:</strong> Die Datei ".$imgorg." ist schreibgesch&uuml;tzt!");
    }

    if (is_file($text_file)) unlink($text_file) or die("<strong>FEHLER:</strong> Die Datei $text_file konnte nicht gel&ouml;scht werden!");
    $imgthumb=$src . "thumbs/". $img;
    if (is_file($imgthumb)) unlink($imgthumb) or die("<strong>FEHLER:</strong> Die Datei $imgthumb konnte nicht gel&ouml;scht werden!");
    if ($img_nr == 0) $img_nr = 1; else $img_nr -= 1; 
    $size -=1;
  }

  /* Text loeschen */
  if ($_POST['delText'] && is_file($text_file)) {
    unlink($text_file) or die("<strong>FEHLER:</strong> Die Datei $text konnte nicht gel&ouml;scht werden!");
  }
}

// Die 'text'-Variable enthaelt den Dateinamen
function save($text) {
  global $src, $safemode;
  global $img_title, $img_text;
  if (!is_dir($src . "text")) {
    if (!$safemode) {
      mkdir($src . "text", 0777) or die("<strong>Error:</strong> Das Verzeichnis \"text\" konnte nicht angelegt werden! Keine Schreibrechte?");
    }
    else die("<strong>FEHLER:</strong> Der Server l&auml;uft im <em>php safe_mode</em>!<br />Das Verzeichnis &quot;text&quot; muss im Verzeichnis &quot;$src&quot; manuell angelegt und mit Schreibrechten versehen werden, damit das Skript trotzdem funktioniert!");
  }
  if (!file_exists($text)) {
    touch($text);
  }
  if (is_writeable($text)) {
    $f = fopen($text, "w"); 
    fwrite($f, "<?php\n\$img_title=\"" . $img_title . "\";\n\$img_text=\"" . $img_text . "\";\n\$img_title_ger=\"" . str_replace("\"", "'", $_POST['new_title']) . "\";\n\$img_text_ger=\"" . str_replace("\"", "'", $_POST['new_text']) . "\";\n?>\n")
	or die("<strong>Error:</strong> der Kommentar konnte nicht abgespeichert werden!");
    fclose($f);
  }
  else {
    print "<strong>FEHLER:</strong> Die Datei $text ist schreibgesch&uuml;tzt!";
    exit;
  }
}

print "<head>\n<title>" . $img_title_ger . " - " . stripslashes($TITLE_D) . "</title>";

?>

<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CHARSET ?>" />
<meta name="description" content="Foto-Galerie erzeugt mit dFG V<?php echo $DFG_VERSION ?> (http://dfg.fieroch.de)" />
<meta name="robots" content="follow" />
  <?php

print $HEAD_D;

/* image_dir variable needed for loading next image and to get the image size */
if ($RESIZE_IMG && !$full_size && is_file($src . $IMGDIR_DEFAULT . "/" . $img)){
 $image_dir = $src . $IMGDIR_DEFAULT;  // verkleinertes Bild im Ordner $IMG_DEFAULT
 }
else{
 $image_dir = $dir;
}

$img_size = GetImageSize($image_dir . "/" . $img);

// Benoetigt fuer div-Groesse
if ($full_size || !$RESIZE_IMG) // Fuer grosse Bilder wird die Breite immer getestet...
  $img_max_width = $img_size[0];
else // ...fuer verkleinerte Bilder kennen wir die maximale Breite schon
  $img_max_width = $IMG_WIDTH;

/* Beim Tippen von Bild-Beschreibungen stoert die Tastatur-Navigation! */
if (!$_POST['verwalten']) { 
?>
<script type="text/javascript"><!--
document.onkeypress = keyevent;
function keyevent(e) {
  /* vor: */
  key_n = 110;   key_j = 106;  // "n", "j" for next
  /* zurueck:
  previous (p) oder back (b) */
  key_p = 112;   key_k = 107;  // "p", "k" for previous
  /* thumbnails:
  up (u) oder thumbnails (t) */
  key_u = 117;   key_m = 109;

  if (navigator.appName == "Netscape") { 
    keyval = e.which; 
  }
  else {
    keyval = window.event.keyCode; 
  }
  if (keyval == key_u || keyval == key_m) {
    location = "galerie.php?src=<?php print urlencode($src); ?>&seite=<?php print $seite; ?>";
    return true; 
  }
  <?php if ($img_nr != 0) { ?>
  if (keyval == key_k || keyval == key_p) {
    location = "bild.php?src=<?php print urlencode($src) . "&img=" . $img_left; if($full_size) print "\&full_size=1"; ?>"; 
    return true; 
  }
  <?php 
  }
  if ($img_nr != $size-1) { ?>
  if (keyval == key_n || keyval == key_j) { 
    location = "bild.php?src=<?php print urlencode($src) . "&img=" . $img_right; if($full_size) print "\&full_size=1" ?>"; 
    return true; 
  }
  <?php } ?>
  return; 
}
<?php

  /* Load the next image in advance */
  $ref=$_SERVER['HTTP_REFERER'];
  /* only works if coming from previous image */
if (strpos($ref, "bild.php")){
  if (strpos($ref, $img_right))
    $preload_image = $image_dir ."/". $img_left;
  else
    $preload_image = $image_dir ."/". $img_right;
    
  /* Repair image name, if given without ".jpg" extension: */
  if (!is_file($preload_image))
    $preload_image = $preload_image . ".jpg";

  print "\n/* preload next image */";
  print "\nnext_image      =  new Image();";
  print "\nnext_image.src  =  \"" . $preload_image . "\";";
}

?>

-->
</script>
<?php } ?>
</head>

<body>
<?php 

/* im Verzeichnis $IMGDIR_DEFAULT ein Bild $IMG_DEF zu $IMG_DEF_SRC ablegen */
function createDefaultSize($imgsrc, $file) { 
  global $IMGDIR_DEFAULT; 
  global $IMG_WIDTH; 
  global $MID_SIZE_QUALITY;
  global $src;

  $img_size = GetImageSize($imgsrc);

  $typ = $img_size[2]; // JPG oder PNG

  /* Querformat oder Hochformat? */
  if ($img_size[0] > $img_size[1]) {
    // Querformat
    $w = $IMG_WIDTH; //default Breite
    $h = $w * $img_size[1]/$img_size[0];
  }
  else {
    // Hochformat
    $h = $IMG_WIDTH; //default Hoehe
    $w = $h * $img_size[0]/$img_size[1];
  }

  if (!$safemode) @set_time_limit(0);
  $imgneu = imagecreatetruecolor($w, $h);

  if ($typ == 2) $imgdef = ImageCreateFromJpeg($imgsrc);
  else if ($typ == 3) $imgdef = ImageCreateFromPNG($imgsrc);

  ImageCopyResampled($imgneu, $imgdef, 0, 0, 0, 0, $w, $h, $img_size[0], $img_size[1]) or die("Fehler beim Erzeugen des Bildes");
  if ($typ == 2) ImageJPEG($imgneu, $src .$IMGDIR_DEFAULT."/".$file, $MID_SIZE_QUALITY) or die("Fehler beim Speichern des Bildes");
  else if ($typ == 3) ImagePNG($imgneu, $src .$IMGDIR_DEFAULT."/".$file, $MID_SIZE_QUALITY) or die("Fehler beim Speichern des Bildes");
}

?>


<div class="top_frame">

<div style="width:<?php echo $img_max_width + 8; ?>px; text-align:center; margin:auto;">
<div style="text-align:left">
  <?php if ($TITLE_ON_IMAGE_PAGE) {
    print "\n<h2>" . $img_title_ger . " - " . stripslashes($TITLE_D) . "</h2>\n<h3>" . stripslashes($SUBTITLE) . "</h3>\n";
    }
   ?>
</div>

<div class="filename"><?php print strip_jpg($img); ?></div>
<div class="img_nr">Bild <strong><?php print $img_nr+1 . "/" . $size ?></strong></div>

<div class="img_navi">
<?php

  if ($img_nr != 0) {  /* not the first image -> display arrow to go back */
  $left_arrow_size = GetImageSize($LEFT);
  print "<a href=\"bild.php?src=" . urlencode($src) . "&amp;img=" . $img_left . ($full_size? "&amp;full_size=1" : "") . "\">";
  print "<img src=\"" . $LEFT . "\" alt=\"&larr;\" title=\"Zur&uuml;ck (Taste 'p')\" width=\"" . $left_arrow_size[0] . "\" height=\"" . $left_arrow_size[1] . "\" />";
  print "</a>\n"; }

  $up_arrow_size = GetImageSize($UP);
  print "<a href=\"galerie.php?src=" . urlencode($src) . "&amp;seite=" . $seite . "\">";
  print "<img src=\"" . $UP . "\" width=\"" . $up_arrow_size[0] . "\" height=\"" . $up_arrow_size[1] . "\" alt=\"&uarr;\" title=\"Mini-Bilder (Taste 'm')\" />";
  print "</a>\n";

  if ($img_nr != $size-1) { /* not the last image -> display arrow to go forward */
  $right_arrow_size = GetImageSize($RIGHT);
  print "<a href=\"bild.php?src=" . urlencode($src) . "&amp;img=" . $img_right . ($full_size? "&amp;full_size=1" : "") . "\">";
  print "<img src=\"" . $RIGHT . "\" alt=\"&rarr;\" title=\"Weiter (Taste 'n')\" width=\"" . $right_arrow_size[0] . "\" height=\"" . $right_arrow_size[1] . "\" /></a>"; }
?>

</div>

<?php

  if ($RESIZE_IMG){ // Wenn mit zwei Bildgroessen gearbeitet wird...
    /* Link auf dem Bild: gross auf klein, klein auf gross */
    print "<a href=\"bild.php?src=" . urlencode($src) . "&amp;img=" . strip_jpg($img) . ($full_size? "" : "&amp;full_size=1") . "\" title=\"Gr&ouml;&szlig;e &auml;ndern\">";
  }

  if ($RESIZE_IMG && !$full_size) { // verkleinertes Bild im Ordner $IMG_DEFAULT
    if (!is_dir($src . $IMGDIR_DEFAULT)) { // ... Order muss eventuell erst erzeugt werden
      mkdir($src . $IMGDIR_DEFAULT, 0775);
      if (!chmod($src . $IMGDIR_DEFAULT, 0775)) {
        echo "<strong>FEHLER: </strong>Die Zugriffsrechte von ".$src . $IMGDIR_DEFAULT." konnten nicht gesetzt werden!";
        exit;
      }
    }
    if (!is_file($src . $IMGDIR_DEFAULT ."/". $img)) { // ggf. verkleinertes Bild erzeugen
      $imgsrc = $dir ."/". $img;
      createDefaultSize($imgsrc, $img);
    }

    print "<img class=\"single_img\" src=\"". $src . $IMGDIR_DEFAULT ."/". $img ."\" alt=\"". $img ."\" title=\"\" width=\"" . $img_size[0] . "\" height=\"" . $img_size[1] . "\" />";

  }
  else { // nicht-verkleinertes Bild
    print "<img class=\"single_img\" src=\"". $dir ."/". $img ."\" alt=\"". $img ."\" title=\"\" width=\"" . $img_size[0] . "\" height=\"" . $img_size[1] . "\" />";
  }
  if ($RESIZE_IMG){ print "</a>"; }
?>
  
<?php // Textfile
if ($img_text_ger !== "") {
  print '<div class="img_txt">';
  print stripslashes($img_text_ger);
  print "</div>";
}


// Admin-Zugriff
@session_start();
if (($_COOKIE["dfg-Admin"] != null && $PASSWORD == $_COOKIE['dfg-Admin']) || ($_SESSION['login']==1)) {
  if ($_POST['verwalten']) {
    print "<form method=\"post\" action=\"".$_SERVER['REQUEST_URI']." \">";
    print "\n<input type=\"hidden\" value=\"true\" name=\"saveText\" />";
    print "\n<div style=\"vertical-align:top;\"><strong>Titel: </strong>\n<input name=\"new_title\" type=\"text\" size=\"50\" value=\"" . ($img_title_ger) . "\" />";
    print "\n<br><strong>Kommentar/Text: </strong>";
    print "\n<textarea name=\"new_text\" cols=\"80\" rows=\"10\" >";
    print stripslashes($img_text_ger);
    print "</textarea>\n</div>";
    print "<div style=\"color:white;background-color:red;\">Doppelte \"Anf&uuml;hrungszeichen\" werden in 'einfache' umgewandelt! Mit &amp;quot; k&ouml;nnen doppelte kodiert werden.</div>";
    print "\n<input type=\"submit\" value=\"speichern\" name=\"save\" style=\"font-weight:bold; width:140px; height:25px; margin-top:20px;\" /></form>";
    
    print "\n<form method=\"post\" action=\"".$_SERVER['REQUEST_URI']." \">";
    print "<div style=\"margin-left:20%; margin-top:20px; margin-bottom:10px; text-align:left\"><strong>Dateien verwalten:</strong></div>";
    print "<div style=\"margin-left:20%; text-align:left\">";
    print "<input type=\"checkbox\" name=\"chk_rename\" size=\"30\" value=\"rename\" style=\"margin-right:10px\" />Bild umbenennen";
    print "<input type=\"text\" name=\"rename\" size=\"15\" value=\"". $img ."\" style=\"margin-left:10px; padding:2px; text-align:right; \" /><br />";
    print "<input type=\"checkbox\" name=\"delImg\" size=\"30\" value=\"delImg\" style=\"margin-top:20px; margin-right:10px; \" />Bilddaten l&ouml;schen (Originalbild, Anzeigebild, Thumbnail und Text)<br />";
    print "<input type=\"checkbox\" name=\"delText\" size=\"30\" value=\"delText\" style=\"margin-right:10px\" />Text/Kommentar l&ouml;schen</div><br />";
    print "<input type=\"submit\" value=\"&uuml;bernehmen\" name=\"apply\" style=\"font-weight:bold; width:140px; height:25px; margin-top:20px;\" /></form>";
    print '<div style="text-align:right; margin-right:5px;"><a href="dfg-konf.php">dfg-Konfiguration</a></div>';
    
  }  
  else { 
    print "<form method=\"post\" action=\"". $_SERVER['REQUEST_URI'] ."\">";
    print '<input type="hidden" value="true" name="verwalten" />';
    print '<input type="submit" value="Bilddaten verwalten" name="edit" style="font-weight:bold; width:200px; height:25px; margin-top:20px;" />';
    print '</form>';
  }
}
?> 

<!-- DO NOT REMOVE THE COPYRIGHT OR YOU OFFEND AGAINST THE LICENSE AGREEMENT!!!
NICHT DAS COPYRIGHT ENTFERNEN ODER DU VERSTOESST GEGEN DAS LIZENZ-ABKOMMEN!!! //-->
	<div class="copyright">Galerie erzeugt mit <a href="http://www.vlado-do.de/download/downloadD.html#dfg" title="dFG herunterladen">dFG V<?php echo $DFG_VERSION; ?></a><br />&copy; by Alexander Fieroch<br /></div>

</div>

</div>
</body>
</html>
