<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<?php  
require 'dfg-conf.inc.php';
include 'dfg_version.php';

/* Galerie-Beschreibungen auf Deutsch: */
$THUMBS_TXT="fotos.txt";

$src = $_GET['src'];
if (!preg_match("/[\/]$/", $src)) $src = $src . "/";

if (!isset($_GET['seite'])) $seite=1;
else $seite = $_GET['seite'];

if (is_file($src . "fotos-conf.inc.php")) include $src . 'fotos-conf.inc.php';

// Engl. Titel nehmen, falls keine deutschen verfuegbar:
if (!isset($TITLE_D) || ($TITLE_D == "" && $TITLE !== ""))
  $TITLE_D = $TITLE;

?>

<head>
  <title>Bildbeschreibungen - <?php echo stripslashes($TITLE_D); ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CHARSET ?>" />
  <meta name="description" content="Foto-Galerie erzeugt mit dFG V<?php echo $DFG_VERSION ?> (http://dfg.fieroch.de)" />
  <meta name="robots" content="follow" />
  <?php print $HEAD_D; ?>
</head>

<body>

<p class="backlink">Zur&uuml;ck zur

<?php 

print "<a href=\"galerie.php?src=" . $src . "\">Galerie</a></p>";

/* hier werden die Thumbnails eingelesen */
$dir = $src . "thumbs";
if ($handle = opendir($dir)) {

  while (false !== ($file = readdir($handle))) { 
    if (is_file($dir."/".$file)) {
      $thumbs[] = $file;

    }
  }
  sort($thumbs);
  
  /* errechnet die bentigte Seitenanzahl */
  $size = count($thumbs);
	
  closedir($handle); 
}
?>


<div class="top_frame">

<a name="Top"></a>


<div style="text-align:left">
<h1 class="title"><?php echo $TITLE_D; ?> - Alle Bildbeschreibungen</h1>
<h2 class="subtitle"><?php echo stripslashes($SUBTITLE); ?></h2>
</div> 

<?php 
/* Beschreibung der Thumbnails / THUMBS_TXT */
$text = $src . $THUMBS_TXT;
if (file_exists($text)) {
  print "<div class=\"thumbtext\">";
  @readfile($text);
  print "</div>";
}


/* the main event */

print "<table class=\"descr\">\n<colgroup><col width=\"" . ($THUMB_SIZE + 6) . "\" /><col width=\"*\" /></colgroup>";


for ($i = 0; $i < $size; $i++) {

print "\n<tr><td>";

/* get_img_title */
  $img_name = $thumbs[$i];
  $img_title = "";
  $img_title_ger = $img_name;
  $img_text_ger = "";
  $img_text = "";
  $text_file= $src . "text/" . $img_name . ".txt";
  if (file_exists($text_file)) {
    /* overrides $img_title, if successful */
    include $text_file;
  }
  /* Falls es keinen deutschen, aber einen engl. Titel gibt wird der genommen: */
  if ( ($img_title_ger == $img_name || $img_title_ger == "") && $img_title !== "")
    $img_title_ger = $img_title; 
/* end get_img_title */

    $pic_link = "<a href=\"bild.php?src=" . urlencode($src) . "&amp;img=" . strip_jpg($img_name) . "\">";
    print $pic_link . "<img src=\"" . $dir . "/" . $img_name . "\" alt=\"" . strip_jpg($img_name) . "\" /></a>";
    print "</td>\n<td class=\"descr\">";
    print "<h2>" . $pic_link . $img_title_ger . "</a></h2>";
    if ($img_text_ger == "" && $img_text !== "")
      print "<i>Englische Beschreibung:</i><br />" . stripslashes($img_text);
    else
      print stripslashes($img_text_ger);
    print "</td></tr>";
}

print "</table>";

?>

<p class="clear">
<a href="#Top" class="trenner"><img src="pic/xgoup.png" width="26" height="26" alt="hoch" title="Zum Seitenanfang" /></a>
</p>

<!-- DO NOT REMOVE THE COPYRIGHT OR YOU OFFEND AGAINST THE LICENSE AGREEMENT!!!
NICHT DAS COPYRIGHT ENTFERNEN ODER DU VERSTSST GEGEN DAS LIZENZ-ABKOMMEN!!! //-->
	<div class="copyright">Gallery created with <a href="http://www.vlado-do.de/download/downloadE.html#dfg" title="dFG download">dFG V<?php echo $DFG_VERSION; ?></a><br />&copy; by <a href="http://www.fieroch.de/" title="Alex Homepage">Alexander Fieroch</a><br /></div>

</div>
</body>
</html>
