<?php
@session_start();

if (!($_COOKIE["dfg-Admin"] != null && $PASSWORD == $_COOKIE['dfg-Admin']) || $_SESSION['login']!=0) {
  if (!($_SESSION['login'])) header("Location: dfg-login.php");
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtm
l1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<?php
$root = "../"; 
include 'dfg_version.php';
include 'dfg-conf.def.inc.php';
if (is_file("dfg-conf.inc.php")) include 'dfg-conf.inc.php';
?> 

<head> 
<title>dFG V<?php echo $DFG_VERSION; ?> Admin</title> 
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CHARSET ?>" />
<meta name="description" content="Photo gallery created with dFG V<?php echo $DFG_VERSION ?> (http://dfg.fieroch.de)" />
<style type="text/css"> 
<!-- 
  input { margin-left:20px; }
  .h { border-style:solid; border-width: 1px; border-color:#99c; background-color:#bbb; margin:8px; margin-left:0px; padding:2px; -moz-border-radius:3px; -moz-background-clip:padding; }
  textInput { text-align:right; margin-left:5px; vertical-align:text-bottom; }
--> 
</style> 
</head> 
 
<body> 

<div class="layout"> 
<a id="Top"></a> 
<div style="text-align:center"><h1>dFG V<?php echo $DFG_VERSION; ?> Administration</h1></div>

<?php
include 'dfg-conf.inc.php';
$galerie_cfg = "dfg-conf.inc.php";

/* Standard-Konfiguration anzeigen */
if ($_POST['anzeige'] == "dfg-conf") {
  if (is_file("dfg-conf.inc.php")) {
    include 'dfg-conf.inc.php';
    $galerie_cfg = "dfg-conf.inc.php";
  }
}
else if ($_POST['anzeige'] == "fotos-conf") {
  $galerie = $_POST['galerie_conf'];
  if (is_dir($galerie)) {
    if (!preg_match("/[\/]$/", $galerie)) $galerie = $galerie . "/";
    if (is_file($galerie."fotos-conf.inc.php")) {
      include $galerie."fotos-conf.inc.php";
      $galerie_cfg = $galerie."fotos-conf.inc.php";
      $anzeige_custom = 'checked="checked"';
    }
    else die("<strong>Error:</strong> the configuration \"<em>".$galerie."fotos-conf.inc.php</em>\" does not exist yet! Please create it first!");
  }
  else {
    die("<strong>Error:</strong> the Gallery \"<em>".$galerie."</em>\" does not exist!");
  }
}



/* als Standard speichern */
if ($_POST['save']) {

  $CONFIG="<?php

/* Zusaetzliche Header-Zeilen */
\$HEAD=\"".$_POST['HEAD']."\";
\$HEAD_D=\"".$_POST['HEAD_D']."\";

/* Bitte hier den Titel eintragen, der fr alle Bilder angezeigt werden soll */
\$TITLE=\"".$_POST['TITLE']."\";

/* Deutscher Titel, wenn Zweitsprache Deutsch */
\$TITLE_D=\"".$_POST['TITLE_D']."\";

/* Hier kann eine zweite &Uuml;berschrift angegeben werden - z.B. ein Datum */
\$SUBTITLE=\"".$_POST['SUBTITLE']."\";

/* Was noch vor der berschrift auf der Galerieseite angezeigt wird - z.B. Navigationselemente */
\$TOP_NAV = \"".$_POST['TOP_NAV']."\";

/* Dasselbe in Deutsch, wenn es Zweitsprache ist */
\$TOP_NAV_D = \"".$_POST['TOP_NAV_D']."\";

/* Ob aus den Bildtiteln berschriften fr die Bildseiten gemacht werden sollen */
\$TITLE_ON_IMAGE_PAGE = \"".$_POST['TITLE_ON_IMAGE_PAGE']."\";

/* Ob die Bildtitel auf der Thumbs-Seite angezeigt werden sollen (sonst: als title-Attribut) */
\$TITLES_ON_THUMBS = \"".$_POST['TITLES_ON_THUMBS']."\";

/* Character set to display in HTML headers */
\$CHARSET = \"".$_POST['CHARSET']."\";

/* Pfeile: zurck, hoch, nchste */
\$LEFT = \"".$_POST['LEFT']."\";
\$UP = \"".$_POST['UP']."\";
\$RIGHT = \"".$_POST['RIGHT']."\";

/* Flags / Graphics for choice of language */
\$FLAG_E = \"".$_POST['FLAG_E']."\";
\$FLAG_D = \"".$_POST['FLAG_D']."\";
\$FLAG_E_ALT = \"".$_POST['FLAG_E_ALT']."\";
\$FLAG_D_ALT = \"".$_POST['FLAG_D_ALT']."\";
\$FLAG_E_TITLE = \"".$_POST['FLAG_E_TITLE']."\";
\$FLAG_D_TITLE = \"".$_POST['FLAG_D_TITLE']."\";

/* true:  Bilder werden auf \$IMG_WIDTH Pixel Breite gesetzt 
          und im Verzeichnis \$IMGDIR_DEFAULT gespeichert
          Default-Bilder sind auf das Originalbild verlinkt
   false: Originalbilder werden unverndert bernommen;
          kein Link
*/
\$RESIZE_IMG = \"".$_POST['RESIZE_IMG']."\";
\$IMG_WIDTH = \"".$_POST['IMG_WIDTH']."\";
\$IMGDIR_DEFAULT = \"".$_POST['IMGDIR_DEFAULT']."\";


/* Qualitt von verkleinerten Bildern */
\$MID_SIZE_QUALITY = \"".$_POST['MID_SIZE_QUALITY']."\";

/* Gre und Qualitt der Thumbnails */
\$THUMB_SIZE = \"".$_POST['THUMB_SIZE']."\";
\$THUMB_QUALITY = \"".$_POST['THUMB_QUALITY']."\";

/* Anzahl Thumbnails pro Seite
 in Vierer-Schritten, also 4, 8, 12, 16, 20 usw.
*/
\$BPS = ".$_POST['BPS'].";

?>";
  
  echo '<div style="text-align:left; margin-top:100px; margin-bottom:100px">';

  if ($_POST['config'] == "standard") { // dfg-conf.inc.php
    if (is_writeable("dfg-conf.inc.php")) {
      $f = fopen("dfg-conf.inc.php", "w"); 
      fwrite($f, $CONFIG) or die("<strong>Error:</strong> could not save the configuration!");
      fclose($f);
      print "The configuration was saved in file \"<em>dfg-conf.inc.php</em>\".<br />";
      print "<a href=\"dfg-admin.php\">back</a>";
      exit;
    }
    else {
      die("<strong>Error:</strong> file \"<em>dfg-conf.inc.php</em>\" is write-protected!");
    }
  }
  else if ($_POST['config'] == "special") { // fotos-conf.inc.php
    $galerie = $_POST['galerie'];
    if (is_dir($galerie)) {
      if (!preg_match("/[\/]$/", $galerie)) $galerie = $galerie . "/";
      if (!is_file($galerie."fotos-conf.inc.php")) touch($galerie."fotos-conf.inc.php", 0700);
      if (is_writeable($galerie."fotos-conf.inc.php")) {
	$f = fopen($galerie."fotos-conf.inc.php", "w"); 
	fwrite($f, $CONFIG) or die("<strong>Error:</strong> could not save the configuration!");
	fclose($f);
	print "The configuration was saved in file \"<em>".$galerie."fotos-conf.inc.php</em>\".<br />";
	print "<a href=\"dfg-admin.php\">back</a>";
	exit;
      }
      else {
	die("<strong>Error:</strong> file \"<em>".$galerie."fotos-conf.inc.php</em>\" is write-protected!");
      }
    }
    else {
      die("<strong>Error:</strong> the gallery \"<em>".$galerie."</em>\" does not exist!");
    }
  }
  /* default-Konfiguration wiederherstellen */
  else if ($_POST['config'] == "default") {
    if (is_writeable("dfg-conf.inc.php") && is_file("dfg-conf.def.inc.php") && (copy("dfg-conf.def.inc.php", "dfg-conf.inc.php")) ) {
      print 'The default was restored.<br />';
      print "<a href=\"dfg-admin.php\">back</a>";
      exit;
    }
    else die("<strong>Error:</strong> could not restore default configuration!");
  }
  print '</div>';
}
?>

<div style="border-style:solid; border-width: 1px; border-color:#99c; background-color:#ccc; color:#000; margin:auto; margin-top:1em; margin-bottom:1em; -moz-border-radius:6px; -moz-background-clip:padding; padding:1em; padding-bottom:5px; padding-top:5px; width:70%">

<div style="font-family:'arial', sans-serif; letter-spacing:3pt; padding:1em; padding-bottom:5px; padding-top:5px; background-color:#777; color:#fff; -moz-border-radius:6px; -moz-background-clip:padding; margin-bottom:25px; ">This configuration is: <em><strong><?php echo $galerie_cfg; ?></strong></em></div>

<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">



<div style="margin-bottom:30px;">
<p class="h"><strong>Gallery Title:</strong></p>
<input type="text" name="TITLE" size="30" value="<?php print stripslashes($TITLE); ?>" class="input" />
<p class="h"><strong>Title in German (for bilingual pages):</strong></p>
<input type="text" name="TITLE_D" size="30" value="<?php print stripslashes($TITLE_D); ?>" class="input" />
<p class="h"><strong>Subtitle:</strong></p>
<input type="text" name="SUBTITLE" size="30" value="<?php echo $SUBTITLE; ?>" class="input" />
<br><br><input type="checkbox" name="TITLE_ON_IMAGE_PAGE" size="30" value="title_on_image_page" <?php if ($TITLE_ON_IMAGE_PAGE) echo'checked="checked"'; ?> class="input" style="margin-right:10px" />Show titles on image pages (needs space above navigation and image)<br />
</div>

<p class="h"><strong>Text at the gallery's beginning:</strong></p>
<textarea name="TOP_NAV" cols="80" rows="2" class="input"><?php echo $TOP_NAV; ?></textarea><p>This text is displayed above the title on the thumbnail page.</p><br />
<textarea name="TOP_NAV_D" cols="80" rows="2" class="input"><?php echo $TOP_NAV_D; ?></textarea><p>Same in German (for bilingual pages).</p><br />

<p class="h"><strong>Additional HTML header lines:</strong></p>
<textarea name="HEAD" cols="80" rows="2" class="input"><?php echo $HEAD; ?></textarea><p>Link at least one CSS file.</p><br />
<textarea name="HEAD_D" cols="80" rows="2" class="input"><?php echo $HEAD_D; ?></textarea><p>Same in German (for bilingual pages).</p><br />

<p>Character set (z.B. <i>utf-8</i>, <i>ascii</i>, or <i><b>iso-8859-1</b></i>): <input type="text" name="CHARSET" size="30" value="<?php echo $CHARSET; ?>" />
<br /><small>Problem: This configuration page is always displayed in the default configuration's character set and saves configuration strings in this character set too!</small></p>

<div style="margin-bottom:30px;">

<p class="h"><strong>Thumbnails per page:</strong></p>
<select name="BPS" size="1" style="margin-left:20px; width:75px;">
<?php
for ($i = 4; $i<41; $i++) {
  if ($i%4 == 0) {
    echo "<option";
    if ($i == $BPS) echo ' selected="selected"';
    echo ">$i</option>\n";
  }
}
?>
</select>
<p>The maximum number of thumbnails for one page.</p><br />

<input type="checkbox" name="TITLES_ON_THUMBS" size="30" value="titles_on_thumbs" <?php if ($TITLES_ON_THUMBS) echo 'checked="checked"'; ?> class="input" style="margin-right:10px" />Show image names (file name, if no title is available) on the thumbnails page. If deactivated you get see pop-up titles when hovering your mouse pointer over the images.<br />

<div style="margin-bottom:30px;">
<p class="h"><strong>Arrows:</strong></p>
<table style="border:none">
  <colgroup>
  <col width="50px" />
  <col width="250px" />
  <col width="*" />
  </colgroup>

  <tr>
    <td>left:</td>
    <td><input type="text" name="LEFT" size="30" value="<?php echo $LEFT; ?>" /></td>
    <td>Last choice: <img style="margin:5px; vertical-align:middle" src="<?php echo $LEFT; ?>" alt="" /></td>
  </tr>
  <tr>
    <td>up:</td>
    <td><input type="text" name="UP" size="30" value="<?php echo $UP; ?>" /></td>
    <td>Last choice: <img style="margin:5px; vertical-align:middle" src="<?php echo $UP; ?>" alt="" /></td>
  </tr>
  <tr>
    <td>right:</td>
    <td><input type="text" name="RIGHT" size="30" value="<?php echo $RIGHT; ?>" /></td>
    <td>Last choice: <img style="margin:5px; vertical-align:middle" src="<?php echo $RIGHT; ?>" alt="" /></td>
  </tr>
</table>
<p>The arrows are used to navigate between images.</p>
</div>

<div style="margin-bottom:30px;">
<p class="h"><strong>Graphics for the choice of language:</strong></p>
<table style="border:none">
  <colgroup>
  <col width="50px" />
  <col width="250px" />
  <col width="*" />
  </colgroup>
  <tr>
    <td>FLAG_E:</td>
    <td><input type="text" name="FLAG_E" size="30" value="<?php echo $FLAG_E; ?>" /></td>
    <td rowspan=3>Last choice: <img style="margin:5px; vertical-align:middle" src="<?php echo $FLAG_E; ?>" alt="" /></td>
  </tr>
  <tr>
    <td>FLAG_E_ALT:</td>
    <td><input type="text" name="FLAG_E_ALT" size="30" value="<?php echo $FLAG_E_ALT; ?>" /></td>
  </tr>
  <tr>
    <td>FLAG_E_TITLE:</td>
    <td><input type="text" name="FLAG_E_TITLE" size="30" value="<?php echo $FLAG_E_TITLE; ?>" /></td>
  </tr>
  <tr>
    <td>FLAG_D:</td>
    <td><input type="text" name="FLAG_D" size="30" value="<?php echo $FLAG_D; ?>" /></td>
    <td rowspan=3>Last choice: <img style="margin:5px; vertical-align:middle" src="<?php echo $FLAG_D; ?>" alt="" /></td>
  </tr>
  <tr>
    <td>FLAG_D_ALT:</td>
    <td><input type="text" name="FLAG_D_ALT" size="30" value="<?php echo $FLAG_D_ALT; ?>" /></td>
  </tr>
  <tr>
    <td>FLAG_D_TITLE:</td>
    <td><input type="text" name="FLAG_D_TITLE" size="30" value="<?php echo $FLAG_D_TITLE; ?>" /></td>
  </tr>
</table>
<p>Graphics are only shown if a title in the other language is set.</p>
</div>

<div style="margin-bottom:50px;">
<p class="h"><strong>Image size and quality</strong></p>
<input type="checkbox" name="RESIZE_IMG" size="30" value="resize" <?php if ($RESIZE_IMG) echo'checked="checked"'; ?> class="input" style="margin-right:10px" />change image size:<br />
<br />
The thumbnails will not be linked with the original images, but dFG creates images in a medium resolution. The maximum width and height will be <input type="text" name="IMG_WIDTH" size="4" value="<?php echo $IMG_WIDTH; ?>" title="e.g. 800 for 800 pixels" class="textInput" /> pixels (the aspect ratio stays the same). They will be saved in  <input type="text" name="IMGDIR_DEFAULT" size="18" value="<?php echo $IMGDIR_DEFAULT; ?>" title="the directory for medium size images" class="textInput" /> and linked with the original images.<br />
When switched off we don't get the medium size images (appropriate for low resolution images).
<br /><input type="text" name="MID_SIZE_QUALITY" size="2" value="<?php echo $MID_SIZE_QUALITY; ?>" title="Recommendation: 75" class="textInput" /> Quality of medium size images (0 - 99)
</div>

<div style="margin-bottom:50px;">
<p class="h"><strong>Thumbnail size and quality:</strong></p>
<br /><input type="text" name="THUMB_QUALITY" size="2" value="<?php echo $THUMB_QUALITY; ?>" title="Recommendation: 75" class="textInput" /> Quality of thumbnail images (0 - 99)
<br /><input type="text" name="THUMB_SIZE" size="3" value="<?php echo $THUMB_SIZE; ?>" title="Common choices are 100 - 150 pixels" class="textInput" /> Maximum dimension of thumbnails
</div>

<br />

<div style="border-top-style:solid; border-top-width:2px; border-color:#99c; margin-bottom:25px; "></div>


<div style="margin-bottom:20px;">
<div style="margin-bottom:15px;"><strong>Execute:</strong></div>
<input type="radio" name="config" value="none" checked="checked" /> don't change anything<br />
<input type="radio" name="config" value="standard" /> write default configuration for all galleries (<em><strong>dfg-conf.inc.php</strong></em>)<br />
<input type="radio" name="config" value="default" /> Restore default configuration of <em><strong>dfg-conf.inc.php</strong></em><br />
<input type="radio" name="config" value="special" style="margin-top:5px;" /> save the configuration for the following gallery in the directory of that name (<em><strong>fotos-conf.inc.php</strong></em>):
<br />
<input type="text" name="galerie" size="25" value="<?php if ($_POST['galerie_conf'] != null) echo $_POST['galerie_conf']; else echo 'meineBilder' ; ?>" class="input" title="Pfad zur Galerie" style="margin-top:5px; margin-left:40px;" /><br />

<br />

<div style="margin-bottom:15px;"><strong>Which configuration to display:</strong></div>
<input type="radio" name="anzeige" value="dfg-conf" style="margin-top:5px;" <?php if (!isset($anzeige_custom)) echo 'checked="checked"'; ?> /> default configuration for all galleries (<em><strong>dfg-conf.inc.php</strong></em>)<br />
<input type="radio" name="anzeige" value="fotos-conf" style="margin-top:5px;" <?php echo $anzeige_custom ; ?> /> load the following gallery's configuration (<em><strong>fotos-conf.inc.php</strong></em>):<br />
<input type="text" name="galerie_conf" size="25" value="<?php if ($_POST['galerie_conf'] != null) echo $_POST['galerie_conf']; else echo 'meineBilder' ; ?>" class="input" title="Pfad zur Galerie" style="margin-top:5px; margin-left:40px;" /><br />
</div>

<div style="border-top-style:solid; border-top-width:2px; border-color:#99c;"></div>

<div style="text-align:center; margin-top:20px; margin-bottom:60px; ">
<input type="hidden" value="true" name="save" />
<input type="submit" value="ok" name="apply" style="font-weight:bold; width:180px; height:30px; " />
<input type="reset" value="Werte zur&uuml;cksetzen" name="reset" style="font-weight:bold; width:180px; height:30px; " />
</div>
</form>

</div>

 
</div> 
</body> 
</html> 
